/**
 * All of the springs.
 */
function LockPickingSprings(id, key, master, springsActive) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    var amountOfSprings = 5;

    var image = new LockPickingPreloadingSpring();

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Creates the springs.
     */
    function populateSprings() {
        for (var i = 0; i < springsActive; i++) {
            that.springs.push(new LockPickingSpring(id, key, master, i, true));
        }
        for (var i = springsActive; i < amountOfSprings; i++) {
            that.springs.push(new LockPickingSpring(id, key, master, i, false));
        }
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.springs = [];


    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns the HTML.
     */
    this.build = function () {
        var output = "";
        for (var i = 0; i < that.springs.length; i++) {
            output += that.springs[i].build();
        }
        return output;
    };

    /**
     * Preloads all assets required, if they have not yet already been loaded.
     */
    this.preload = function () {
        return image.preload();
    };

    /**
     * Causes the specified spring to go up.
     * @param {int} which Which tumbler needs to go up.
     * @param {int} time How quickly it should go up, in milliseconds.
     */
    this.up = function (which, time) {
        that.springs[which].up(time);
    };

    this.stopSpring = function (position) {
        that.springs[position].stop();
    };

    this.reset = function () {
        for (var i = 0; i < springsActive; i++) {
            that.springs[i].reset();
        }
    };

    populateSprings();
}
