/**
 * The bridge section of the Forest scene.
 * @param {ForestController} controller The forest controller.
 */
function ForestBridge(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    //var pathSelection = new ForestIntroductionPathSelection(ctrl);
    //var itemSelection = new ForestIntroductionItemSelection(ctrl, pathSelection);
    //var recovering = new ForestIntroductionRecovering(ctrl, itemSelection);
    
    // PRIVATE FUNCTIONS \\     function privateFunction(){}
    
    
    // PUBLIC MEMBERS \\        this.public = "test";

    // The id of this segment.
    this.id = "forestBridge";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};
    
    /**
     * Builds and returns this part.
     */
    this.build = function() {
        if (!ctrl.intro.hasMadePathChoice()) {
            return "";
        }
        if (ctrl.intro.getPathChoice() !== ForestIntroductionPathChoiceEnum.BRIDGE) {
            return "";
        }
        var introduction = `<div id="${that.id}">`;
        introduction += `<div class="text">bridge</div>`
        introduction += `</div>`;
        return introduction;
    };
    
    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function() {
        if (!ctrl.intro.hasMadePathChoice()) {
            return;
        }
        if (ctrl.intro.getPathChoice() !== ForestIntroductionPathChoiceEnum.BRIDGE) {
            return;
        }
    };
}

