/**
 * Overdressed section of Varanar, Noon Three.
 * @param {VaranarSoupKitchenController} controller The Varanar, Noon Three controller.
 */
function VaranarSoupKitchenBluffFail(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.preContinue;
    var changeController = ctrl.bluffFail;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.apple;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            You bluff, saying that you are a member of the Three-Tailed Rat Clan.
                            This explains why you're so well-dressed and a bit more [i]wealthy[/i] than the other kobolds around town.
                            Unless the sheep is looking for [b]trouble[/b], he'd best get to serving you, and make it snappy.
                            The clan can make life [b]very[/b] difficult for [i]uncooperative[/i] people.
                            Surely he doesn't want to get on their -- you mean [b]your[/b] -- bad side one day after [i]retirement[/i], right?
                        [/p]
                        ${global.ui.condFail(`Strength below 6`)}
                        [p]
                            "[color=ppink]You?
                            A [b]gang member[/b]?
                            Don't make me [b]laugh[/b], [i]kuhbold[/i].
                            With [b]wimpy[/b] little arms like that, ye can be glad people don't mistake ye for an overgrown [b]grasshopper[/b].[/color]"
                            The man snorts, almost laughing at his own joke.
                            "[color=ppink]You're a bad liar, lizard.
                            Come now, we don't serve liars here.
                            Git.
                            Out the door.
                            Or do I need tah [b]throw[/b] yeh out?[/color]"
                        [/p]
                        [p]
                            No.
                            [b]No![/b]
                            Does he know what he's doing?!
                            You're part of a [b]crime syndicate[/b]!
                            You'll have him [b]killed[/b]!
                            "[color=ppink]Yeah right.
                            And me wife, Armok rest'er soul, was a faithful woman, too?
                            Do ye expect me tah believe everythin' without questionin', lizard?
                            Yer a dirty, no-good liar.
                            Now get out of mah soup kitchen.
                            We're [b]closed[/b].
                            [b]Forever[/b].[/color]"
                        [/p]
                        [p]
                            That being said, the fat sheep points towards the door.
                            You wordlessly continue you act, in a last ditch attempt to get him to let you stay.
                            He looks like he's made his choice.
                            You try to come up with something, [b]anything[/b] to say, but it's hopeless.
                            Your scrawny figure has cost you a valuable opportunity.
                            Hanging your head, you walk out the door, back towards the market square.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
